package main

import (
    "github.com/360EntSecGroup-Skylar/excelize"
    "math/rand"
    "strconv"
)

func main() {
    // ファイルを読み込み
    f, _ := excelize.OpenFile("bingo-template.xlsx")
    // 100回ビンゴシートを作る
    for i := 1; i <= 100; i++ {
        sname := "bingo" + strconv.Itoa(i)
        index := f.NewSheet(sname)
        f.CopySheet(0, index)
        makeSheet(f, sname)
    }
    // テンプレートシートを削除
    f.DeleteSheet("template")
    // 保存
    f.SaveAs("bingo.xlsx")
}

func makeSheet(f *excelize.File, sname string) {
    // 1から75までのスライスを作成
    a := []int{}
    for i := 1; i <= 75; i++ {
        a = append(a, i)
    }
    // スライスをシャッフル
    for i := 74; i >= 0; i-- {
        j := rand.Intn(i + 1)
        a[i], a[j] = a[j], a[i]
    }
    // シートに書き込む
    for i := 0; i < 25; i++ {
        y := i/5 + 2
        x := i%5 + 1
        cn, _ := excelize.ColumnNumberToName(x)
        cn += strconv.Itoa(y)
        if cn == "C4" {
            continue
        }
        f.SetCellValue(sname, cn, a[i])
    }
}
